---
operationId: "recoverProject"
method: "POST"
path: "/projects/{project_id}/recover"
tag: "projects"
stability: "beta"
interfaces: ["api", "sdk", "cli"]
---
> API Reference / Projects / Recover a deleted project

## POST /projects/{project_id}/recover

Recovers a deleted project within the 7-day deletion recovery period.
Restores branches, endpoints, settings, and connection strings.
Some integrations require manual reconfiguration after recovery.
To list recoverable projects, use `GET /projects?recoverable=true`.


### Parameters

- `project_id` (string, path, required)
  The Neon project ID

### Response (200)

- `project` (object, optional)
  - `data_storage_bytes_hour` (integer, required, format: int64)
    Bytes-Hour. Project consumed that much storage hourly during the billing period. The value has some lag.
    The value is reset at the beginning of each billing period.
    
  - `data_transfer_bytes` (integer, required, format: int64)
    Bytes. Egress traffic from the Neon cloud to the client for given project over the billing period.
    Includes deleted endpoints. The value has some lag. The value is reset at the beginning of each billing period.
    
  - `written_data_bytes` (integer, required, format: int64)
    Bytes. Amount of WAL that travelled through storage for given project across all branches.
    The value has some lag. The value is reset at the beginning of each billing period.
    
  - `compute_time_seconds` (integer, required, format: int64)
    Seconds. The number of CPU seconds used by the project's compute endpoints, including compute endpoints that have been deleted.
    The value has some lag. The value is reset at the beginning of each billing period.
    Examples:
    1. An endpoint that uses 1 CPU for 1 second is equal to `compute_time=1`.
    2. An endpoint that uses 2 CPUs simultaneously for 1 second is equal to `compute_time=2`.
    
  - `active_time_seconds` (integer, required, format: int64)
    Seconds. Control plane observed endpoints of this project being active this amount of wall-clock time.
    The value has some lag.
    The value is reset at the beginning of each billing period.
    
  - `cpu_used_sec` (integer, required, deprecated, format: int64)
    DEPRECATED, use compute_time instead.
    
  - `id` (string, required)
    The project ID
  - `platform_id` (string, required)
    The cloud platform identifier. Currently, only AWS is supported, for which the identifier is `aws`.
    
  - `region_id` (string, required)
    The region identifier
    
  - `name` (string, required)
    The project name
    
  - `provisioner` (string, required)
    The Neon compute provisioner.
    Specify the `k8s-neonvm` provisioner to create a compute endpoint that supports Autoscaling.
    
    Provisioner can be one of the following values:
    * k8s-pod
    * k8s-neonvm
    * serverless-platform
    
    Clients must expect, that any string value that is not documented in the description above should be treated as a error. UNKNOWN value if safe to treat as an error too.
    
  - `default_endpoint_settings` (object, optional)
    A collection of settings for a Neon endpoint
    - `pg_settings` (object, optional)
      A raw representation of Postgres settings
    - `pgbouncer_settings` (object, optional, deprecated)
      DEPRECATED. PgBouncer settings for the compute endpoint. This field is deprecated and will be removed after 2026-06-20.
      
    - `autoscaling_limit_min_cu` (number, optional)
      The minimum number of Compute Units. The minimum value is `0.25`.
      See [Compute size and Autoscaling configuration](https://neon.com/docs/manage/endpoints#compute-size-and-autoscaling-configuration)
      for more information.
      
    - `autoscaling_limit_max_cu` (number, optional)
      The maximum number of Compute Units. See [Compute size and Autoscaling configuration](https://neon.com/docs/manage/endpoints#compute-size-and-autoscaling-configuration)
      for more information.
      
    - `suspend_timeout_seconds` (integer, optional, format: int64)
      Duration of inactivity in seconds after which the compute endpoint is
      automatically suspended. The value `0` means use the default value.
      The value `-1` means never suspend. The default value is `300` seconds (5 minutes).
      The minimum value is `60` seconds (1 minute).
      The maximum value is `604800` seconds (1 week). For more information, see
      [Scale to zero configuration](https://neon.com/docs/manage/endpoints#scale-to-zero-configuration).
      
  - `settings` (object, optional)
    - `quota` (object, optional)
      Per-project consumption quotas. If a quota is exceeded, all active computes
      are automatically suspended and cannot be started via API calls or incoming connections.
      
      The exception is `logical_size_bytes`, which is enforced per branch.
      If a branch exceeds its `logical_size_bytes` quota, computes can still be started,
      but write operations will fail—allowing data to be deleted to free up space.
      Computes on other branches are not affected.
      
      Setting `logical_size_bytes` overrides any lower value set by the `neon.max_cluster_size` Postgres setting.
      
      Quotas are enforced using per-project consumption metrics with the same names.
      These metrics reset at the start of each billing period. `logical_size_bytes`
      is also an exception—it reflects the total data stored in a branch and does not reset.
      
      A zero or empty quota value means “unlimited.”
      
      - `active_time_seconds` (integer, optional, format: int64)
        The total amount of wall-clock time allowed to be spent by the project's compute endpoints.
        
      - `compute_time_seconds` (integer, optional, format: int64)
        The total amount of CPU seconds allowed to be spent by the project's compute endpoints.
        
      - `written_data_bytes` (integer, optional, format: int64)
        Total amount of data written to all of a project's branches.
        
      - `data_transfer_bytes` (integer, optional, format: int64)
        Total amount of data transferred from all of a project's branches using the proxy.
        
      - `logical_size_bytes` (integer, optional, format: int64)
        Limit on the logical size of every project's branch.
        
        If a branch exceeds its `logical_size_bytes` quota, computes can still be started,
        but write operations will fail—allowing data to be deleted to free up space.
        Computes on other branches are not affected.
        
        Setting `logical_size_bytes` overrides any lower value set by the `neon.max_cluster_size` Postgres setting.
        
    - `allowed_ips` (object, optional)
      A list of IP addresses that are allowed to connect to the compute endpoint.
      If the list is empty or not set, all IP addresses are allowed.
      If protected_branches_only is true, the list will be applied only to protected branches.
      
      - `ips` (array, optional)
        A list of IP addresses that are allowed to connect to the endpoint.
      - `protected_branches_only` (boolean, optional)
        If true, the list will be applied only to protected branches.
    - `enable_logical_replication` (boolean, optional)
      Sets wal_level=logical for all compute endpoints in this project.
      All active endpoints will be suspended.
      Once enabled, logical replication cannot be disabled.
      
    - `maintenance_window` (object, optional)
      A maintenance window is a time period during which Neon may perform maintenance on the project's infrastructure.
      During this time, the project's compute endpoints may be unavailable and existing connections can be
      interrupted.
      
      - `weekdays` (array, required)
        A list of weekdays when the maintenance window is active.
        Encoded as ints, where 1 - Monday, and 7 - Sunday.
        
      - `start_time` (string, required)
        Start time of the maintenance window, in the format of "HH:MM". Uses UTC.
        
      - `end_time` (string, required)
        End time of the maintenance window, in the format of "HH:MM". Uses UTC.
        
    - `block_public_connections` (boolean, optional)
      When set, connections from the public internet
      are disallowed. This supersedes the AllowedIPs list.
      This parameter is under active development and its semantics may change in the future.
      
    - `block_vpc_connections` (boolean, optional)
      When set, connections using VPC endpoints are disallowed.
      This parameter is under active development and its semantics may change in the future.
      
    - `audit_log_level` (string, optional)
      Possible values: `base`, `extended`, `full`
    - `hipaa` (boolean, optional)
    - `preload_libraries` (object, optional)
      The shared libraries to preload into the project's compute instances.
      
      - `use_defaults` (boolean, optional)
      - `enabled_libraries` (array, optional)
  - `pg_version` (integer, required)
    The major Postgres version number. Generally available versions are `14`, `15`, `16`, `17`, and `18`. `19` is being rolled out and is only accepted in regions where it has been enabled; requesting it in a region where it is not yet available returns an error.
    Default: `17`
  - `proxy_host` (string, required)
    The proxy host for the project. This value combines the `region_id`, the `platform_id`, and the Neon domain (`neon.tech`).
    
  - `branch_logical_size_limit` (integer, required, format: int64)
    The logical size limit for a branch. The value is in MiB.
    
  - `branch_logical_size_limit_bytes` (integer, required, format: int64)
    The logical size limit for a branch. The value is in B.
    
  - `store_passwords` (boolean, required)
    Whether or not passwords are stored for roles in the Neon project. Storing passwords facilitates access to Neon features that require authorization.
    
  - `maintenance_starts_at` (string, optional, format: date-time)
    A timestamp indicating when project maintenance begins. If set, the project is placed into maintenance mode at this time.
    
  - `creation_source` (string, required)
    The project creation source
    
  - `history_retention_seconds` (integer, required, format: int32)
    The number of seconds to retain the shared history for all branches in this project.
    
  - `created_at` (string, required, format: date-time)
    A timestamp indicating when the project was created
    
  - `updated_at` (string, required, format: date-time)
    A timestamp indicating when the project was last updated
    
  - `synthetic_storage_size` (integer, optional, format: int64)
    The current space occupied by the project in storage, in bytes. Synthetic storage size combines the logical data size and Write-Ahead Log (WAL) size for all branches in a project.
    
  - `consumption_period_start` (string, required, format: date-time)
    A date-time indicating when Neon Cloud started measuring consumption for current consumption period.
    
  - `consumption_period_end` (string, required, format: date-time)
    A date-time indicating when Neon Cloud plans to stop measuring consumption for current consumption period.
    
  - `quota_reset_at` (string, optional, deprecated, format: date-time)
    DEPRECATED. Use `consumption_period_end` from the getProject endpoint instead.
    A timestamp indicating when the project quota resets.
    
  - `owner_id` (string, required)
  - `owner` (object, optional)
    - `email` (string, required, format: email)
    - `name` (string, required)
    - `branches_limit` (integer, required)
    - `subscription_type` (string, required)
      Type of subscription to Neon Cloud.
      Notice that for users without billing account this will be "UNKNOWN"
      
      Possible values: `UNKNOWN`, `direct_sales`, `direct_sales_v3`, `aws_marketplace`, `free_v2`, `free_v3`, `launch`, `launch_v3`, `scale`, `scale_v3`, `business`, `vercel_pg_legacy`
  - `compute_last_active_at` (string, optional, format: date-time)
    The most recent time when any endpoint of this project was active.
    
    Omitted when observed no activity for endpoints of this project.
    
  - `org_id` (string, optional)
  - `maintenance_scheduled_for` (string, optional, format: date-time)
    A timestamp indicating when project update begins. If set, computes might experience a brief restart around this time.
    
  - `hipaa_enabled_at` (string, optional, format: date-time)
    A timestamp indicating when HIPAA was enabled for this project
  - `effective_project_permission` (string, optional)
    The caller's effective permission for a project when
    per-project permissions are enabled. `VIEWER` grants read access,
    `EDITOR` adds update access, and `ADMIN` grants full management.
    Omitted for personal projects, flag-off organizations, and non-user
    subjects.
    
    Possible values: `VIEWER`, `EDITOR`, `ADMIN`
- `branches` (array, optional)
  - `id` (string, required)
    The branch ID. This value is generated when a branch is created. A `branch_id` value has a `br` prefix. For example: `br-small-term-683261`.
    
  - `project_id` (string, required)
    The ID of the project to which the branch belongs
    
  - `parent_id` (string, optional)
    The `branch_id` of the parent branch
    
  - `parent_lsn` (string, optional)
    The Log Sequence Number (LSN) on the parent branch from which this branch was created.
    When restoring a branch using the `POST /projects/{project_id}/branches/{branch_id}/restore` endpoint,
    this value isn’t finalized until all operations related to the restore have completed successfully.
    
  - `parent_timestamp` (string, optional, format: date-time)
    The point in time on the parent branch from which this branch was created.
    When restoring a branch using the `POST /projects/{project_id}/branches/{branch_id}/restore` endpoint,
    this value isn’t finalized until all operations related to the restore have completed successfully.
    After all the operations completed, this value might stay empty.
    
  - `name` (string, required)
    The branch name
    
  - `current_state` (string, required)
    The branch’s state, indicating if it is initializing, ready for use, or archived.
      * 'init' - the branch is being created but is not available for querying.
      * 'resetting' - the branch is being reset to a specific point in time or LSN and is not yet available for querying.
      * 'ready' - the branch is fully operational and ready for querying. Expect normal query response times.
      * 'archived' - the branch is stored in cost-effective archival storage. Expect slow query response times.
    
  - `pending_state` (string, optional)
    The branch’s state, indicating if it is initializing, ready for use, or archived.
      * 'init' - the branch is being created but is not available for querying.
      * 'resetting' - the branch is being reset to a specific point in time or LSN and is not yet available for querying.
      * 'ready' - the branch is fully operational and ready for querying. Expect normal query response times.
      * 'archived' - the branch is stored in cost-effective archival storage. Expect slow query response times.
    
  - `state_changed_at` (string, required, format: date-time)
    A UTC timestamp indicating when the `current_state` began
    
  - `logical_size` (integer, optional, format: int64)
    The logical size of the branch, in bytes
    
  - `creation_source` (string, required)
    The branch creation source
    
  - `primary` (boolean, optional, deprecated)
    DEPRECATED. Use `default` field.
    Whether the branch is the project's primary branch
    
  - `default` (boolean, required)
    Whether the branch is the project's default branch
    
  - `protected` (boolean, required)
    Whether the branch is protected
    
  - `cpu_used_sec` (integer, required, deprecated, format: int64)
    CPU seconds used by all of the branch's compute endpoints, including deleted ones.
    This value is reset at the beginning of each billing period.
    Examples:
    1. A branch that uses 1 CPU for 1 second is equal to `cpu_used_sec=1`.
    2. A branch that uses 2 CPUs simultaneously for 1 second is equal to `cpu_used_sec=2`.
    
  - `compute_time_seconds` (integer, required, format: int64)
  - `active_time_seconds` (integer, required, format: int64)
  - `written_data_bytes` (integer, required, format: int64)
  - `data_transfer_bytes` (integer, required, format: int64)
  - `created_at` (string, required, format: date-time)
    A timestamp indicating when the branch was created
    
  - `updated_at` (string, required, format: date-time)
    A timestamp indicating when the branch was last updated
    
  - `ttl_interval_seconds` (integer, optional)
    The time-to-live (TTL) duration originally configured for the branch, in seconds. This read-only value represents the interval between the time `expires_at` was set and the expiration timestamp itself. It is preserved to ensure the same TTL duration is reapplied when resetting the branch from its parent, and only updates when a new `expires_at` value is set.
    
    Access to this feature is currently limited to participants in the Early Access Program.
    
  - `expires_at` (string, optional, format: date-time)
    The timestamp when the branch is scheduled to expire and be automatically deleted. Must be set by the client following the [RFC 3339, section 5.6](https://tools.ietf.org/html/rfc3339#section-5.6) format with precision up to seconds (such as 2025-06-09T18:02:16Z). Deletion is performed by a background job and may not occur exactly at the specified time.
    
    Access to this feature is currently limited to participants in the Early Access Program.
    
  - `last_reset_at` (string, optional, format: date-time)
    A timestamp indicating when the branch was last reset
    
  - `created_by` (object, optional)
    The resolved user model that contains details of the user/org/integration/api_key used for branch creation. This field is filled only in listing/get/create/get/update/delete methods, if it is empty when calling other handlers, it does not mean that it is empty in the system.
    
    - `name` (string, optional)
      The name of the user.
    - `image` (string, optional)
      The URL to the user's avatar image.
  - `init_source` (string, optional)
    The source of initialization for the branch. Valid values are `schema-only` and `parent-data` (default).
      * `schema-only` - creates a new root branch containing only the schema. Use `parent_id` to specify the source branch. Optionally, you can provide `parent_lsn` or `parent_timestamp` to branch from a specific point in time or LSN. These fields define which branch to copy the schema from and at what point—they do not establish a parent-child relationship between the `parent_id` branch and the new schema-only branch.
      * `parent-data` - creates the branch with both schema and data from the parent.
    
  - `restore_status` (string, optional)
    Could be `restored`, `finalized` or `detaching`.
    A `restored` branch becomes permanently `finalized` when you call `finalizeRestoreBranch`
    A `restored` or `finalized` branch may begin `detaching` as a one-time performance optimisation, after which it will continue in its original state
    
  - `restored_from` (string, optional)
    ID of the snapshot that was the restore source for this branch
    
  - `restored_as` (string, optional)
    ID of the target branch which was replaced when this branch was restored
    
  - `restricted_actions` (array, optional)
    A list of actions that are currently restricted for this branch and the reason why.
    
    - `name` (string, required)
      The name of a restricted action. Possible values include `restore`, `delete-rw-endpoint`.
      
    - `reason` (string, required)
      A human-readable explanation of why the action is restricted.
      
  - `recovery` (object, optional)
    Recovery information for a deleted branch. Only present when listing deleted branches
    with `include_deleted=true`.
    
    This is part of the Branch Recovery feature, which is in preview and not available to all users.
    
    - `deleted_at` (string, required, format: date-time)
      Timestamp when the branch was deleted
      
    - `recoverable_until` (string, required, format: date-time)
      Timestamp when the recovery window expires and the branch will be permanently deleted
      
    - `deletion_method` (string, required)
      How the branch was deleted: 'user' for manual deletion, 'ttl' for TTL expiration
      
      Possible values: `user`, `ttl`

### Code examples

```bash
curl "https://console.neon.tech/api/v2/projects/$PROJECT_ID/recover" \
  -X POST \
  -H "Authorization: Bearer $NEON_API_KEY"
```

```typescript
import { createNeonClient, raw } from '@neon/sdk';

const neon = createNeonClient({ apiKey: process.env.NEON_API_KEY });
const { data } = await raw.recoverProject({
  client: neon.client,
  path: {
    project_id: process.env.PROJECT_ID
  }
});
```

```bash
# neonctl
neon projects recover <project_id>
```

### Errors

**default**
General Error.

The request may or may not be safe to retry, depending on the HTTP method, response status code,
and whether a response was received.

- If no response is returned from the API, a network error or timeout likely occurred.
- In some cases, the request may have reached the server and been successfully processed, but the response failed to reach the client. As a result, retrying non-idempotent requests can lead to unintended results.

The following HTTP methods are considered non-idempotent: `POST`, `PATCH`, `DELETE`, and `PUT`. Retrying these methods is generally **not safe**.
The following methods are considered idempotent: `GET`, `HEAD`, and `OPTIONS`. Retrying these methods is **safe** in the event of a network error or timeout.

Any request that returns a `503 Service Unavailable` response is always safe to retry.

Any request that returns a `423 Locked` response is safe to retry. `423 Locked` indicates that the resource is temporarily locked, for example, due to another operation in progress.

- `request_id` (string, optional)
  Unique identifier for the request, useful for debugging.
  You can set this value manually by including an `X-Request-ID` header in the request. If not provided, the value will be generated automatically.
  
- `code` (string, required)
  Default: ``
- `message` (string, required)
  Error message
